Remove Ubuntu Intrepid support - EOL is this month (https://wiki.ubuntu.com/Releases)
[OpenSRF.git] / src / extras / Makefile.install
1 # ---------------------------------------------------------------------
2 # Author: Bill Erickson <erickson@esilibrary.com>
3 #
4 # Makefile to install prerequisites for OpenSRF
5 #
6 # Currently supports Debian (etch/lenny), Ubuntu (hardy/karmic), and Gentoo.
7 # Working towards support of CentOS 5 / RHEL 5.
8 # Installs Perl prereqs, libjs with Perl wrapper
9 #
10 # usage:
11 #       make -f Makefile.install debian-etch
12 #       - or -
13 #       make -f Makefile.install debian-lenny
14 #       - or -
15 #       make -f Makefile.install ubuntu-hardy
16 #       - or -
17 #       make -f Makefile.install ubuntu-karmic
18 #       - or -
19 #       make -f Makefile.install centos
20 #       - or -
21 #       make -f Makefile.install rhel
22 #       - or -
23 #       make -f Makefile.install gentoo
24 #
25 # Notes:
26 #
27 #       This makefile has been tested much more with Ubuntu and Debian than
28 #   CentOS, Gentoo, or RHEL.
29 #
30 #       Gentoo (especially amd64) requires a good bit of masked package
31 #       mangling for some packages.  These are not documented here because
32 #       they will continue to evolve
33 #
34 # ---------------------------------------------------------------------
35
36 # Make any assumptions about the shell being used explicit
37 SHELL=/bin/bash 
38
39 # XXX
40 # Gentoo needs explicit versions on many of these packages
41 # to simulate a "blessed" set of packages
42
43 # ejabberd is not packaged on CentOS/RHEL, so we have to
44 # download the installable package from the source
45 EJABBERD_VER=2.1.2
46 EJABBERD_PKG=ejabberd-2.1.2-linux-x86_64-installer.bin
47 EJABBERD_PKG_x64=ejabberd-2.1.2-linux-x86_64-installer.bin
48 EJABBERD_HOST=http://www.process-one.net/downloads/ejabberd
49
50 # Centos and Redhat will require the rpmforge repository mostly for memcache and perl modules
51 RPMFORGE_PKG=rpmforge-release-0.5.1-1.el5.rf.x86_64.rpm
52 RPMFORGE_HOST=http://packages.sw.be/rpmforge-release
53
54 # need newer libtool, autoconf, and automake on centos
55 AUTOCONF_HOST=http://ftp.gnu.org/gnu/autoconf
56 AUTOCONF_PKG=autoconf-2.65
57 LIBTOOL_HOST=http://ftp.gnu.org/gnu/libtool
58 LIBTOOL_PKG=libtool-2.2.6b
59 AUTOMAKE_HOST=http://ftp.gnu.org/gnu/automake
60 AUTOMAKE_PKG=automake-1.11
61
62 # libmemcached is only packaged on newer distros
63 LIBMEMCACHED=libmemcached-0.35
64 LIBMEMCACHED_HOST=http://download.tangent.org
65
66 # XML::LibXSLT fails due to old libxslt
67 XSLT=libxslt-1.1.22
68 XSLT_HOST=ftp://ftp.gnome.org/pub/GNOME/sources/libxslt/1.1
69
70 # libxslt depends on a newer version of libxml2:
71 XML2=libxml2-2.6.30
72 XML2_HOST=ftp://ftp.gnome.org/pub/GNOME/sources/libxml2/2.6
73
74 APT_TOOL=aptitude -yq
75
76 # Debian dependencies
77 DEBS =  \
78         apache2-mpm-prefork\
79         apache2-prefork-dev\
80         autoconf\
81         automake\
82         build-essential\
83         ejabberd\
84         less\
85         libapache2-mod-perl2\
86         libcache-memcached-perl\
87         libclass-dbi-abstractsearch-perl\
88         libclass-dbi-sqlite-perl\
89         libdatetime-format-builder-perl\
90         libdatetime-format-mail-perl\
91         libdatetime-perl\
92         libdatetime-timezone-perl\
93         liberror-perl\
94         libexpat1-dev\
95         libfile-find-rule-perl\
96         libfreezethaw-perl\
97         libgcrypt11-dev \
98         libgdbm-dev \
99         liblog-log4perl-perl\
100         libmodule-build-perl\
101         libnet-jabber-perl\
102         libperl-dev\
103         libreadline5-dev\
104         librpc-xml-perl\
105         libtemplate-perl\
106         libtest-pod-perl\
107         libtie-ixhash-perl\
108         libtool\
109         libuniversal-require-perl\
110         libunix-syslog-perl\
111         libwww-perl\
112         libxml2-dev\
113         libxml-libxml-perl\
114         libxml-libxslt-perl\
115         libxml-simple-perl\
116         libxslt1-dev\
117         memcached\
118         ntpdate\
119         pkg-config\
120         psmisc\
121         python-dev\
122         python-libxml2\
123         python-setuptools
124
125 CENTOS = \
126         apr-util-devel.x86_64 \
127         autoconf \
128         automake \
129         gcc \
130         gcc-c++ \
131         gdbm-devel \
132         httpd-devel \
133         less \
134         libmemcache-devel \
135         libtool \
136         libxml2-devel \
137         libxslt-devel \
138         make \
139         memcached \
140         mod_perl \
141         mod_ssl \
142         ncurses \
143         ncurses-devel \
144         ntp \
145         perl-Cache-Memcached \
146         perl-Class-DBI-AbstractSearch \
147         perl-Class-DBI-SQLite \
148         perl-DateTime \
149         perl-DateTime-Format-ISO8601 \
150         perl-DateTime-Format-Mail \
151         perl-DateTime-Set \
152         perl-DateTime-TimeZone \
153         perl-DBI \
154         perl-Email-Send \
155         perl-Error \
156         perl-File-Find-Rule \
157         perl-FreezeThaw \
158         perl-JSON-XS \
159         perl-libwww-perl \
160         perl-Log-Log4perl \
161         perl-Memcached-libmemcached \
162         perl-Module-Build \
163         perl-Net-Jabber \
164         perl-Net-Server \
165         perl-RPC-XML \
166         perl-Template-Toolkit \
167         perl-Test-Pod \
168         perl-Tie-IxHash \
169         perl-UNIVERSAL-require \
170         perl-Unix-Syslog \
171         perl-XML-LibXML \
172         perl-XML-LibXSLT \
173         perl-XML-Parser \
174         perl-XML-Simple \
175         perl-XML-RPC \
176         psmisc \
177         python-devel \
178         python-setuptools\
179         readline-devel \
180         wget
181
182 CENTOS_PERL = \
183
184 GENTOOS = \
185         vim\
186         ntp\
187         memcached\
188         libmemcached\
189         net-misc/telnet-bsd\
190         app-portage/gentoolkit\
191         gsasl\
192         ejabberd\
193         mod_perl\
194         net-fs/nfs-utils\
195         dev-libs/apr\
196         dev-perl/Cache-Memcached\
197         dev-perl/DBI\
198         dev-perl/Log-Log4perl\
199         dev-perl/Unix-Syslog\
200         dev-perl/XML-LibXML\
201         dev-perl/XML-LibXSLT\
202         dev-perl/XML-Simple\
203         dev-perl/Net-Jabber\
204         dev-perl/libwww-perl\
205         dev-perl/Template-Toolkit\
206         dev-perl/Error\
207         dev-perl/Tie-IxHash\
208         dev-perl/FreezeThaw
209
210 GENTOO_RC = \
211         ejabberd\
212         memcached\
213         portmap
214
215 GENTOO_PERL = \
216         Class::DBI::AbstractSearch\
217         UNIVERSAL::require
218
219 DEB_APACHE_MODS = \
220         ssl
221
222 EXTRA_DEBS = \
223         libdatetime-format-iso8601-perl \
224         libjson-xs-perl \
225         libnet-server-perl
226
227 EXTRA_DEBS_UBUNTU_KARMIC = \
228         libmemcached-dev\
229         libxml-libxml-perl \
230         libxml-libxslt-perl
231
232 # generic CPAN modules:
233 #   * DateTime::Format::ISO8601 is packaged by both Debian Lenny and Ubuntu Intrepid
234 #   * JSON::XS is packaged by both Debian Lenny and Ubuntu Intrepid
235 #   * libnet-server-perl 0.97 is packaged on Debian Lenny and Ubuntu Intrepid
236 #     - is there a specific need for 0.90?
237 CPAN_MODULES = \
238         DateTime::Format::ISO8601 \
239         RHANDOM/Net-Server-0.90.tar.gz \
240         JSON::XS
241
242 #   libxml-libxml-perl on Debian Lenny and Ubuntu Intrepid is 1.66, which
243 #   has broken namespace handling. so we still need to install these from
244 #   CPAN. *sigh*
245 CPAN_MODULES_XML = \
246         XML::LibXML \
247         XML::LibXSLT
248
249 # generic CPAN modules to force
250 CPAN_MODULES_FORCE = \
251         TMTM/Class-DBI-0.96.tar.gz
252
253 # ----------------------------------------------------------------------------
254
255 all: 
256         @echo "please specify an OS" && exit 0
257
258
259 centos: install_rpmforge install_centos_rpms install_ejabberd install_buildutils install_libmemcached install_libxml2 install_libxslt install_centos_perl create_ld_local
260
261 debian-etch: generic_debian etch install_libmemcached
262 debian-lenny: generic_debian lenny install_libmemcached
263 etch: install_cpan
264 lenny: install_extra_debs
265 generic_debian: install_debs install_cpan_force install_cpan_xml debian_sys_config
266
267 gentoo: install_gentoos install_gentoo_rc install_gentoo_perl install
268
269 rhel: centos
270
271 ubuntu-hardy: generic_ubuntu install_cpan_xml hardy
272 ubuntu-karmic: generic_ubuntu karmic
273 hardy: install_cpan install_libmemcached 
274 karmic: install_extra_debs install_extra_debs_karmic
275 generic_ubuntu: install_debs install_cpan_force debian_sys_config
276
277 # - COMMON TARGETS ---------------------------------------------------------
278
279 # Install the CPAN modules
280 install_cpan: 
281         for m in $(CPAN_MODULES); do perl -MCPAN -e "install \"$$m\";"; done
282
283 # Install CPAN modules that need to be forced
284 install_cpan_force: 
285         for m in $(CPAN_MODULES_FORCE); do perl -MCPAN -e "CPAN::Shell->force(qw#install $$m#);"; done
286
287 # Install the CPAN XML modules
288 install_cpan_xml: 
289         for m in $(CPAN_MODULES_XML); do perl -MCPAN -e "install \"$$m\";"; done
290
291 # Install ejabberd from official project installer binary
292 install_ejabberd:    
293         if [ ! -f $(EJABBERD_PKG).gz ]; then wget $(EJABBERD_HOST)/$(EJABBERD_VER)/$(EJABBERD_PKG).gz; fi;
294         gunzip $(EJABBERD_PKG).gz
295         chmod u+x $(EJABBERD_PKG)
296         ./$(EJABBERD_PKG) --mode unattended --prefix /opt/ejabberd --adminpw opensrf
297
298 # Install rpmforge for redhat and centos
299 install_rpmforge:
300         if [ ! -f $(RPMFORGE_PKG).gz ]; then wget $(RPMFORGE_HOST)/$(RPMFORGE_PKG); fi;
301         rpm -Uvh --force ./$(RPMFORGE_PKG)
302         yum update -y
303
304 # Install automake, autoconf, and libtool
305 install_buildutils:
306         if [ ! -f $(LIBTOOL_PKG).tar.gz ]; then wget $(LIBTOOL_HOST)/$(LIBTOOL_PKG).tar.gz; fi;
307         tar zxf $(LIBTOOL_PKG).tar.gz
308         cd $(LIBTOOL_PKG) && ./configure --prefix=/usr && make && make install
309
310         if [ ! -f $(AUTOCONF_PKG).tar.gz ]; then wget $(AUTOCONF_HOST)/$(AUTOCONF_PKG).tar.gz; fi;
311         tar zxf $(AUTOCONF_PKG).tar.gz
312         cd $(AUTOCONF_PKG) && ./configure --prefix=/usr && make && make install
313         
314         if [ ! -f $(AUTOMAKE_PKG).tar.gz ]; then wget $(AUTOMAKE_HOST)/$(AUTOMAKE_PKG).tar.gz; fi;
315         tar zxf $(AUTOMAKE_PKG).tar.gz
316         cd $(AUTOMAKE_PKG) && ./configure --prefix=/usr && make && make install
317
318 # Install libmemcached from the official project source
319 install_libmemcached:
320         if [ ! -d $(LIBMEMCACHED).tar.gz ]; then wget $(LIBMEMCACHED_HOST)/$(LIBMEMCACHED).tar.gz; fi;
321         tar xzf $(LIBMEMCACHED).tar.gz
322         cd $(LIBMEMCACHED) && ./configure && make && make install
323
324 # Install a newer version of libxslt
325 install_libxslt:    
326         if [ ! -d $(XSLT) ]; then wget $(XSLT_HOST)/$(XSLT).tar.gz; fi;
327         tar xzf $(XSLT).tar.gz
328         cd $(XSLT) && ./configure --with-libxml-prefix=/usr/local && make && make install
329
330 # Install a newer version of libxml2
331 install_libxml2:    
332         if [ ! -d $(XML2) ]; then wget $(XML2_HOST)/$(XML2).tar.gz; fi;
333         tar xzf $(XML2).tar.gz
334         cd $(XML2) && ./configure && make && make install
335
336 clean:
337         make -C $(LIBJS_PERL) clean
338         make -C $(XML2) clean
339         make -C $(XSLT) clean
340         make -f Makefile.ref -C js/src/ clean
341
342
343 # ------------------------------------------------------------------
344 # - DEBIAN ---------------------------------------------------------
345
346 debian_sys_config: 
347         # link the apache modules in
348         for m in $(DEB_APACHE_MODS); do a2enmod $$m; done;
349
350         # adds a placeholder module so apxs will be happy
351         if [ ! "$$(grep mod_placeholder /etc/apache2/httpd.conf)" ]; then \
352                 echo -e "#\n#LoadModule mod_placeholder /usr/lib/apache2/modules/mod_placeholder.so" \
353                         >> /etc/apache2/httpd.conf; \
354         fi;
355
356 # Install the debian-specific dependencies
357 install_debs:
358         $(APT_TOOL) install $(DEBS)
359
360 # Install the debian-specific dependencies for more modern distros
361 install_extra_debs:
362         $(APT_TOOL) install $(EXTRA_DEBS)
363
364 # Install even more packaged dependencies on modern distros
365 install_extra_debs_karmic:
366         $(APT_TOOL) install $(EXTRA_DEBS_UBUNTU_KARMIC)
367
368 # ------------------------------------------------------------------
369 # - GENTOO ---------------------------------------------------------
370
371 install_gentoos:
372         emerge -n $(GENTOOS)
373
374 install_gentoo_rc:
375         for m in $(GENTOO_RC); do rc-update add $$m default; done;
376
377 install_gentoo_perl:
378         for m in $(GENTOO_PERL); do perl -MCPAN -e "install \"$$m\";"; done
379
380 # ------------------------------------------------------------------
381
382 # CENTOS
383 install_centos_rpms:
384         yum -y install $(CENTOS)
385
386 install_centos_perl:
387         for m in $(CENTOS_PERL_FORCE); do perl -MCPAN -e "CPAN::Shell->force(qw#install $$m#);"; done
388         for m in $(CENTOS_PERL); do perl -MCPAN -e "install \"$$m\";"; done
389         for m in $(CENTOS_PERL_VERSION); do perl -MCPAN -e "CPAN::Shell->install \"$$m\";"; done
390         for m in $(CENTOS_PERL_NOTEST); do perl -MCPAN -e "CPAN::Shell->notest('install', \"$$m\";"; done
391         for m in $(CENTOS_PERL_LOCAL); do LD_LIBRARY_PATH=/usr/local/lib:/usr/lib:/lib perl -MCPAN -e "install \"$$m\";"; done
392
393 # We need to add /usr/local/lib to the ldconfig list of directories on CentOS,
394 # if it is not already there
395 create_ld_local:
396         if [ "$$(ldconfig -v 2> /dev/null | grep '^/usr/local/lib' | wc -l)" -eq 0 ]; then \
397                 echo '/usr/local/lib' > /etc/ld.so.conf.d/local.conf; \
398                 ldconfig; \
399         fi;
400
401 # vim:noet:sw=4:ts=4: